# core_ops:  the  non-GUI parts

set dx {1 5 9}
set dy {3 4 8}
set dz {2 6 7}

proc depot2xy {xyz xn yn} { upvar 1 $xn xp $yn yp
    foreach {x y z} [split $xyz {}] {break}
    set w [expr {(2*$y + $z) % 3}]; set v [expr {2*$y + $w}]
    switch $x {
      2 { set X $w; set Y [expr {$v % 6}] }
      1 { set X [expr {$w + 3}]; set Y [expr {($v + 3) % 6}] }
      0 { set X [expr {$w + 3*(($v % 6)/3)}]; set Y [expr {$v % 3 + 6}] }
    }
    set xp [expr {$X * 3}]; set yp $Y
}

proc target2xy {tgt xn yn} { upvar 1 $xn xp $yn yp
    global targetpos; foreach {xp yp} $targetpos($tgt) {break}
}

proc placetile {xyz tgt} { global tiles target
    set target($tgt) $xyz; set tiles($xyz) $tgt
}
proc removetile {xyz} { global tiles target
    set target($tiles($xyz)) {}; set tiles($xyz) {}
}
proc tile_at {tgt} { global target
    return $target($tgt)
}
proc target_of {xyz} { global tiles
    return $tiles($xyz)
}

proc init_core {} {
    global target tiles targetlist tilelist targetpos

    set targetlist {}
    foreach x {0 1 2 3 4} {foreach y {0 1 2 3 4} {
        set z [expr {$x*5+$y}]; if {$z<2 || $z==5 || $z==19 || $z>22} continue
        set ch [format {%c} [expr {$z+65}]]
        set targetpos($ch) [list [expr {$x*3}] [expr {$x+2*$y-2}]]
        set target($ch) {}; lappend targetlist $ch
    }}

    set l {0 1 2}
    foreach x $l {foreach y $l {foreach z $l { 
        set tiles($x$y$z) {} 
        lappend tilelist $x$y$z
    }}}

}

proc count {} {
    set sum 0
    # | #
    incr sum [count_aux 0 C D E]
    incr sum [count_aux 0 G H I J]
    incr sum [count_aux 0 K L M N O]
    incr sum [count_aux 0 P Q R S]
    incr sum [count_aux 0 U V W]
    # \ #
    incr sum [count_aux 1 E J O]
    incr sum [count_aux 1 D I N S]
    incr sum [count_aux 1 C H M R W]
    incr sum [count_aux 1 G L Q V]
    incr sum [count_aux 1 K P U]
    # / #
    incr sum [count_aux 2 K G C]
    incr sum [count_aux 2 P L H D]
    incr sum [count_aux 2 U Q M I E]
    incr sum [count_aux 2 V R N J]
    incr sum [count_aux 2 W S O]
    return $sum
}

proc count_aux {dir org args} { global target dx dy dz
    set dd [lindex {dx dy dz} $dir]
    set v [string index $target($org) $dir]; set c 1
    if {$v=={}} {return 0}
    foreach tgt $args { incr c
        set x [string index $target($tgt) $dir]
        if {$x!=$v} {return 0}
    }
    return [expr {[lindex [set $dd] $v]*$c}]
}

init_core
